/*
 * VLAICU VICTOR ALEXANDRU 334CC
 */

#define F_CPU 16000000

#include "lcd.h"

#include <avr/io.h>
#include <util/delay.h>

#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6

#define MORSE_LUNG		150
#define MORSE_SCURT		50
#define MORSE_PAUZA		50

#define NUM_NOTE		8

int frecventa_nota[NUM_NOTE] = {
	262, 294, 330, 349, 392, 440, 494, 523
};

#define LUNG_SECV 6
#define NR_SECV 8

int level = 0;
int id = 0;
int vieti = 3;
int control = 0;
int secventa[8][7] = { { 0, 1, 2, 3, 2, 0 },
						{ 1, 2, 2, 3, 2, 1 },
						{ 0, 1, 2, 3, 3, 1 },
						{ 1, 2, 1, 0, 1, 2 },
						{ 0, 1, 0, 3, 2, 3 },
						{ 2, 3, 0, 0, 0, 2 },
						{ 0, 1, 0, 3, 0, 1 },
						{ 3, 3, 2, 3, 2, 0 } };

/* Genereaza o nota folosind buzzer-ul. */
void buzzer_reda(int nota) {
	int perioada_nota = 1000000 / frecventa_nota[nota];
	int i;

	PORTD |= (1 << PD5);
	for (i = 0; i < perioada_nota / 2; ++i)
		_delay_us(1);

	PORTD &= ~(1 << PD5);
	for (i = 0; i < perioada_nota / 2; ++i)
		_delay_us(1);
}

/* Genereaza sunetul pentru tipul de ton folosit: lung (150ms) sau scurt (50ms). */
void buzzer_morse(int tip_morse) {
	int i;

	/* Alternam starea pinului PD5 la fiecare milisecunda. */
	for (i = 0; i < tip_morse; ++i) {
		PORTD ^= (1 << PD5);

		_delay_ms(1);
	}
}

/* Plays sound for leds */
void play_MUSIC() {

	buzzer_morse(MORSE_LUNG);
	_delay_ms(1);
	buzzer_morse(MORSE_SCURT);
	//_delay_ms(1);
	buzzer_morse(MORSE_LUNG);
	//_delay_ms(1);
	buzzer_morse(MORSE_LUNG);
	_delay_ms(1);
	buzzer_morse(MORSE_SCURT);
	_delay_ms(1);
	buzzer_morse(MORSE_LUNG);


}

void play_MUSIC_2() {

	buzzer_morse(MORSE_LUNG);
	_delay_ms(1);
	buzzer_morse(MORSE_SCURT);
	//_delay_ms(1);
	buzzer_morse(MORSE_LUNG);
	//_delay_ms(1);
	buzzer_morse(MORSE_LUNG);	
}

void play_secv() {

	if (level >= NR_SECV) {
		if (vieti > 0) {
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_print("Winner");
			for (;;);
		} else {
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_print("Lost");
			for (;;);			
		}
	}

	if (vieti <= 0) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("Game over!");
		for (;;);
	}

	int i;

	for (i = 0; i < LUNG_SECV; i++) {

		if (secventa[level][i] == 0) {
			PORTB |= (1 << PB0);
			play_MUSIC();
			PORTB &= ~(1 << PB0);
			_delay_ms(300);
		} else if (secventa[level][i] == 1) {
			PORTB |= (1 << PB1);
			play_MUSIC();
			PORTB &= ~(1 << PB1);
			_delay_ms(300);
		} else if (secventa[level][i] == 2) {
			PORTB |= (1 << PB2);
			play_MUSIC();
			PORTB &= ~(1 << PB2);
			_delay_ms(300);
		} else if (secventa[level][i] == 3) {
			PORTB |= (1 << PB3);
			play_MUSIC();
			PORTB &= ~(1 << PB3);
			_delay_ms(300);
		}
	}
}

void init_level() {

	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);
	_delay_ms(1000);
	PORTB &= ~(1 << PB0);
	PORTB &= ~(1 << PB1);
	PORTB &= ~(1 << PB2);
	PORTB &= ~(1 << PB3);
	_delay_ms(700);
}

void init_level2() {

	PORTB |= (1 << PB0);
	PORTB |= (1 << PB3);
	_delay_ms(1000);
	PORTB &= ~(1 << PB0);
	PORTB &= ~(1 << PB3);
	_delay_ms(700);
}

/* BRAINS */
void exemplu(void) {
	int play = 1;
	
	/* Setez butoanele si rez lor pe pullup */
	DDRD &= ~(1 << PD0);
	PORTD |= (1 << PD0);

	DDRD &= ~(1 << PD1);
	PORTD |= (1 << PD1);

	DDRD &= ~(1 << PD4);
	PORTD |= (1 << PD4);	

	DDRD &= ~(1 << PD6);
	PORTD |= (1 << PD6);

	/* Setam ledurile */
	DDRB |= (1 << PB0);
	PORTB &= ~(1 << PB0);

	DDRB |= (1 << PB1);
	PORTB &= ~(1 << PB1);

	DDRB |= (1 << PB2);
	PORTB &= ~(1 << PB2);

	DDRB |= (1 << PB3);
	PORTB &= ~(1 << PB3);

	DDRD |= (1 << PD7);
	PORTD &= ~(1 << PD7);

	DDRD |= (1 << PD5);
	PORTD &= ~(1 << PD5);

	/* Mesaj lcd */	
	char mesaj1[] = "L   LVL  ";
	LCD_print("Welcome");
	/* Astept pornire joc */	
	_delay_ms(3000);

	while (1) {
		/* Daca secventa e corecta */
		if (id >= LUNG_SECV) {
			id = 0;
			level += 1;
			play = 1;
		}


		char c = vieti + '0';
		mesaj1[2] = c;
		c = level + '0';
		mesaj1[8] = c;
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print(mesaj1);
		_delay_ms(10);

		/* Daca e initial begin sau trebuie redat */
		if (play == 1) {
			init_level();
			play_secv();
			init_level();
			play = 0;

		}

		/* Daca butonul este apasat. */
		if ((PIND & (1 << PD0)) == 0) {
			/* Aprind LED-ul. */
			PORTB |= (1 << PB0);
			//_delay_ms(1000);
			play_MUSIC_2();
			if (id >= LUNG_SECV) {
				PORTB &= ~(1 << PB0);
				init_level2();
				play = 1;
				vieti -= 1;
				id = 0;
			} else if (0 != secventa[level][id]) {
				PORTB &= ~(1 << PB0);
				init_level2();
				play = 1;
				vieti -= 1;
				id = 0;
			} else if (0 == secventa[level][id]) {
				id += 1;
			}
			_delay_ms(50);
		}else{
			/* Sting LED-ul. */
			PORTB &= ~(1 << PB0);		
		}

		/* Daca butonul este apasat. */
		if ((PIND & (1 << PD1)) == 0){
			/* Aprind LED-ul. */
			PORTB |= (1 << PB1);
			play_MUSIC_2();
			//_delay_ms(1000);
			if (id >= LUNG_SECV) {
				PORTB &= ~(1 << PB1);
				init_level2();
				play = 1;
				vieti -= 1;
				id = 0;
			} else if (1 != secventa[level][id]) {
				PORTB &= ~(1 << PB1);
				init_level2();
				play = 1;
				vieti -= 1;
				id = 0;
			} else if (1 == secventa[level][id]) {
				id += 1;
			}
			_delay_ms(50);
		}else{
			/* Sting LED-ul. */
			PORTB &= ~(1 << PB1);
		}

		/* Daca butonul este apasat. */
		if ((PIND & (1 << PD4)) == 0){
			/* Aprind LED-ul. */
			PORTB |= (1 << PB2);
			play_MUSIC_2();
			//_delay_ms(1000);
			if (id >= LUNG_SECV) {
				PORTB &= ~(1 << PB2);
				init_level2();
				play = 1;
				vieti -= 1;
				id = 0;
			} else if (2 != secventa[level][id]) {
				PORTB &= ~(1 << PB2);
				init_level2();
				play = 1;
				vieti -= 1;
				id = 0;
			} else if (2 == secventa[level][id]) {
				id += 1;
			}

			_delay_ms(50);
		}else{
			/* Sting LED-ul. */
			PORTB &= ~(1 << PB2);
		}

		/* Daca butonul este apasat. */
		if ((PIND & (1 << PD6)) == 0){
			/* Aprind LED-ul. */
			PORTB |= (1 << PB3);
			play_MUSIC_2();
			//_delay_ms(1000);
			if (id >= LUNG_SECV) {
				PORTB &= ~(1 << PB3);
				init_level2();
				play = 1;
				vieti -= 1;
				id = 0;
			} else if (3 != secventa[level][id]) {
				PORTB &= ~(1 << PB3);
				init_level2();
				play = 1;
				vieti -= 1;
				id = 0;
			} else if (3 == secventa[level][id]) {
				id += 1;
			}
			_delay_ms(50);
		}else{
			/* Sting LED-ul. */
			PORTB &= ~(1 << PB3);
		}

	}
}

int main(void) {

	MCUCR |= (1<<JTD) ;
	MCUCR |= (1<<JTD);
	LCD_init();	
	exemplu();

	return 0;
}
